#include "xhbGrFinger.ch"
#include "FiveWin.ch"
#xtranslate StrTrim(<n>)   =>  LTrim(Str(<n>))
//-------------------------------------------------------------------------------------------------------------------------
REQUEST DBFCDX
//-------------------------------------------------------------------------------------------------------------------------
static oWndMain
static oGriaulle
static oEnrollCtx
static oSearchCtx
static oFileSensor
static oFingerSensor
static lEnrollMode  := .F.
//-------------------------------------------------------------------------------------------------------------------------
function main()
RddSetDefault( "DBFCDX" )
SetHandleCount( 250 )
SET CENTURY ON
SET EPOCH TO 1930
SET DATE TO BRITISH
SET DELETED ON
if !File("huellas.dbf")
   DbCreate( "huellas.dbf",{{"USER","C",25,0},{"FINGERTPL","M",10,0},{"QUALITY","N",3,0}})
end
USE HUELLAS
if !File("huellas.cdx")
   INDEX ON Upper(User) TAG User TO HUELLAS
else
   SET INDEX TO HUELLAS
end

HUELLAS->( DbGoTop() )

oGriaulle := TGrFinger():New()
//oGriaulle:InstallLicense( "licensekey")
oGriaulle:Initialize()
oEnrollCtx := oGriaulle:CreateContext()
oSearchCtx := oGriaulle:GetContext(0) // default context
oGriaulle:bSensorPlug   := {|oSensor,cId| OnSensorPlug( oSensor , cId ) }
oGriaulle:bSensorUnplug := {|oSensor,cId| OnSensorUnPlug( oSensor , cId ) }
oEnrollCtx:StartEnroll()
oGriaulle:CaptureInit()

DEFINE WINDOW oWndMain TITLE "Test Enroll/search"
   // -------------------------------------------------
   oWndMain:oTop := TPanel():New(0,0,24,10, oWndMain )
   oWndMain:oTop:bResized := {|| BtnBar_OnResize( oWndMain:oTop ) }
   // -------
   @ 0,0 BUTTON "Add"     ACTION Huellas_Add()      OF oWndMain:oTop
   @ 0,0 BUTTON "Edit"    ACTION Huellas_Edit()     OF oWndMain:oTop
   @ 0,0 BUTTON "Delete"  ACTION Huellas_Del()      OF oWndMain:oTop
   @ 0,0 SAY ""           OF oWndMain:oTop
   @ 0,0 CHECKBOX lEnrollMode PROMPT "Enroll Mode" OF oWndMain:oTop
   BtnBar_OnResize( oWndMain:oTop )
   // -------------------------------------------------
   @ 0,0 LISTBOX oWndMain:oClient ;
         FIELDS HUELLAS->USER , Quality2Str( HUELLAS->QUALITY ) ;
         ALIAS "HUELLAS" ;
         HEADER "User","Quality" ;
         OF oWndMain

ACTIVATE WINDOW oWndMain ON INIT WndMain_init()
DbCloseAll()
oEnrollCtx:Destroy() ; oEnrollCtx := NIL
oGriaulle:CaptureExit()
oGriaulle:Finalize()
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function Quality2Str( n )
if     n == 0 ; return "Captura de Mala Calidad "
elseif n == 1 ; return "Captura de Calidad Media"
elseif n == 2 ; return "Captura de Alta Calidad "
end
return ""
//-------------------------------------------------------------------------------------------------------------------------
function WndMain_init()

return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function BtnBar_OnResize( oBar )
local aRect := GetClientRect( oBar:hWnd )
local nn    := Len( oBar:aControls )
local cx,n,x,o,w

if nn > 0
   cx := int( aRect[4] / nn )
   x := 0
   for n := 1 to nn
      w := iif((n==1),(aRect[4] % nn),0)
      oBar:aControls[n]:Move(0,x,cx + w,aRect[3],.T.)
      x += (cx + w)
   next
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function Huellas_Add()
local nRows := oWndMain:oClient:nRowCount()
local cUser := Space(25)
local nRec  := HUELLAS->( RecNo() )
if MsgGet("Aadir Usuario","ID:",@cUser)
   cUser := PadR(AllTrim(cUser),25)
   if Empty( cUser ) ; return NIL ; end
   HUELLAS->( DbGoTop() )
   if HUELLAS->( !DbSeek(cUser) )
      HUELLAS->( DbAppend() )
      HUELLAS->User    := cUser
      HUELLAS->Quality := -1
      oWndMain:oClient:nRowPos := HUELLAS->( OrdKeyNo() )
      if oWndMain:oClient:nRowPos > nRows ; oWndMain:oClient:nRowPos := nRows ; end
      oWndMain:oClient:Refresh(.T.)
   end
   return NIL
end
HUELLAS->( DbGoto( nRec ) )
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function Huellas_Edit()
local nRows := oWndMain:oClient:nRowCount()
local nRec  := HUELLAS->( RecNo() )
local cUser
local lDupe
if HUELLAS->( Eof() .or. Bof() ) ; return NIL ; end
cUser := HUELLAS->User
if MsgGet("Modificar Usuario","ID:",@cUser)
   cUser := PadR(AllTrim(cUser),25)
   if cUser == HUELLAS->User ; return NIL ; end
   if Empty( cUser ) ; return NIL ; end
   HUELLAS->( DbGoTop() )
   lDupe := HUELLAS->( DbSeek(cUser) )
   if lDupe ; return NIL ; end
   HUELLAS->( DbGoto( nRec ) )
   HUELLAS->User    := cUser
   HUELLAS->( DbSkip(0) )
   oWndMain:oClient:nRowPos := HUELLAS->( OrdKeyNo() )
   if oWndMain:oClient:nRowPos > nRows ; oWndMain:oClient:nRowPos := nRows ; end
   oWndMain:oClient:Refresh(.T.)
   return NIL
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function Huellas_Del()
local nRows := oWndMain:oClient:nRowCount()
if HUELLAS->( Eof() .or. Bof() ) ; return NIL ; end
HUELLAS->( DbDelete() , DbSkip(1) )
if HUELLAS->( Eof() )
   HUELLAS->( DbGoBottom() )
   oWndMain:oClient:nRowPos := HUELLAS->( iif( Eof() , 1 , OrdKeyNo() ) )
else
   oWndMain:oClient:nRowPos := HUELLAS->( OrdKeyNo() )
end
if oWndMain:oClient:nRowPos > nRows ; oWndMain:oClient:nRowPos := nRows ; end
oWndMain:oClient:Refresh(.T.)
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function OnImageReady(cRaw,cx,cy,nDpi)
local nQuality  := 0
local cTemplate
local cUser

if !lEnrollMode
   cUser     := cFinger2User( cRaw,cx,cy,nDpi )
   if Empty(cUser)
      MsgInfo( "No conozco esa huella" , "OnImageReady | Enroll == .F." )
   else
      MsgInfo( "Hola " + cUser , "OnImageReady | Enroll == .F." )
   end
   return NIL
end

if HUELLAS->( Eof() ) ; MsgInfo( "EOF" , "OnImageReady | Enroll == .T.") ; return NIL ; end
if HUELLAS->( Bof() ) ; MsgInfo( "BOF" , "OnImageReady | Enroll == .T.") ; return NIL ; end

cTemplate := oEnrollCtx:Enroll(cRaw,cx,cy,nDpi,@nQuality)
if oEnrollCtx:nLastError != 0
   MsgInfo( "Error num " + StrTrim(oEnrollCtx:nLastError) + " enrolando la huella" , "OnImageReady | Enroll == .T.")
   return NIL
end
if MsgYesNo( Quality2Str( nQuality ) + Chr(10) + "Guardamos la huella?" ,"OnImageReady | Enroll == .T." )
   HUELLAS->FINGERTPL := oGriaulle:cBin2Base64( cTemplate )
   oWndMain:oClient:Refresh(.T.)
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function cFinger2User( cRaw,cx,cy,nDpi )
local cUser := NIL
local cTpl := oSearchCtx:Extract(cRaw,cx,cy,nDpi)
local nRec := HUELLAS->( RecNo() )
local cc

if oSearchCtx:nLastError == 0
   if oSearchCtx:IdentifyPrepare( cTpl )
      HUELLAS->( DbGoTop() )
      while HUELLAS->( !Eof() )
         cc := HUELLAS->FINGERTPL
         if !Empty( cc )
            cc := oGriaulle:cBase64ToBin( cc )
            if oSearchCtx:Identify(cc)
               if oSearchCtx:Verify(cTpl,cc)
                  cUser := AllTrim( HUELLAS->User )
                  HUELLAS->( DbGoto( nRec ) )
                  return cUser
               end
            end
         end
         HUELLAS->( DbSkip() )
      end
   end
end
HUELLAS->( DbGoto( nRec ) )
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function OnSensorPlug( oSensor , cId )
if cId == "File"
   oFileSensor := oSensor
else
   oFingerSensor := oSensor
   oSensor:bImageReady   := {|s,cRaw,cx,cy,nDpi| OnImageReady(cRaw,cx,cy,nDpi) }
   oSensor:Start()
end
//MsgInfo( cId , "OnSensorPlug" )
return NIL
//-------------------------------------------------------------------------------------------------------------------------
static function OnSensorUnPlug( oSensor , cId )
if cId == "File"
   oFileSensor := NIL
else
   oFingerSensor := NIL
   oSensor:Stop()
end
//MsgInfo( cId , "OnSensorUnPlug" )
return NIL
//-------------------------------------------------------------------------------------------------------------------------
