//success
#define GR_OK                                         0
#define GR_BAD_QUALITY                                0
#define GR_MEDIUM_QUALITY                             1
#define GR_HIGH_QUALITY                               2
#define GR_MATCH                                      1
#define GR_NOT_MATCH                                  0
#define GR_DEFAULT_USED                               3
#define GR_ENROLL_NOT_READY                           0
#define GR_ENROLL_SUFFICIENT                          1
#define GR_ENROLL_GOOD                                2
#define GR_ENROLL_VERY_GOOD                           3
#define GR_ENROLL_MAX_LIMIT_REACHED                   4
//initialization errors codes
#define GR_ERROR_INITIALIZE_FAIL                     -1
#define GR_ERROR_NOT_INITIALIZED                     -2
#define GR_ERROR_FAIL_LICENSE_READ                   -3
#define GR_ERROR_NO_VALID_LICENSE                    -4
#define GR_ERROR_NULL_ARGUMENT                       -5
#define GR_ERROR_FAIL                                -6
#define GR_ERROR_ALLOC                               -7
#define GR_ERROR_PARAMETERS                          -8
//extract and match errors codes
#define GR_ERROR_WRONG_USE                         -107
#define GR_ERROR_EXTRACT                           -108
#define GR_ERROR_SIZE_OFF_RANGE                    -109
#define GR_ERROR_RES_OFF_RANGE                     -110
#define GR_ERROR_CONTEXT_NOT_CREATED               -111
#define GR_ERROR_INVALID_CONTEXT                   -112
#define GR_ERROR_ERROR                             -113
#define GR_ERROR_NOT_ENOUGH_SPACE                  -114
#define GR_ERROR_BAD_QUALITY                       -115
//capture error codes
#define GR_ERROR_CONNECT_SENSOR                    -201
#define GR_ERROR_CAPTURING                         -202
#define GR_ERROR_CANCEL_CAPTURING                  -203
#define GR_ERROR_INVALID_ID_SENSOR                 -204
#define GR_ERROR_SENSOR_NOT_CAPTURING              -205
#define GR_ERROR_INVALID_EXT                       -206
#define GR_ERROR_INVALID_FILENAME                  -207
#define GR_ERROR_INVALID_FILETYPE                  -208
#define GR_ERROR_SENSOR                            -209
//license error codes
#define GR_ERROR_GET_HARDWARE_KEY                  -301
#define GR_ERROR_INTERNET_CONNECTION               -302 
#define GR_ERROR_BAD_REQUEST                       -303
#define GR_ERROR_INVALID_PRODUCT_KEY               -304
#define GR_ERROR_INSUFFICIENT_CREDIT               -305
#define GR_ERROR_NO_HARDWARE_BOUND                 -306
#define GR_ERROR_HTTP_AUTHORIZATION                -307
#define GR_ERROR_WRONG_PRODUCT_KEY                 -308
#define GR_ERROR_INTERNAL_SERVER                   -309
#define GR_ERROR_WRITING_LICENSE_FILE              -310
#define GR_ERROR_PK_NOT_LINKED                     -311
#define GR_ERROR_PK_NOT_APPROVED                   -312

//*****************************************************
//CONSTS
//*****************************************************
//file format codes
#define GRCAP_IMAGE_FORMAT_BMP                      501
//event values codes
#define GR_PLUG                                      21
#define GR_UNPLUG                                    20
#define GR_FINGER_DOWN                               11
#define GR_FINGER_UP                                 10
#define GR_IMAGE                                     30
//image consts
#define GR_DEFAULT_RES                              500
#define GR_DEFAULT_DIM                              500
#define GR_MAX_SIZE_TEMPLATE                      10000
#define GR_MAX_IMAGE_WIDTH                         1280
#define GR_MAX_IMAGE_HEIGHT                        1280
#define GR_MAX_RESOLUTION                          1000 /*DPI*/
#define GR_MIN_IMAGE_WIDTH                           50
#define GR_MIN_IMAGE_HEIGHT                          50
#define GR_MIN_RESOLUTION                           125 /*DPI*/
//match const
#define GR_MAX_THRESHOLD                            200
#define GR_MIN_THRESHOLD                             10
#define GR_VERYLOW_FRR                               30 /*FAR 1 IN 1000*/
#define GR_LOW_FRR                                   45 /*FAR 1 IN 10000*/
#define GR_LOW_FAR                                   60 /*FAR 1 IN 30000*/
#define GR_VERYLOW_FAR                               80 /*FAR 1 IN 300000*/
#define GR_ROT_MIN                                    0
#define GR_ROT_MAX                                  180
//context const
#define GR_DEFAULT_CONTEXT                            0
#define GR_NO_CONTEXT                                -1
//colors for BiometricDisplay
#define GR_IMAGE_NO_COLOR                    0x1FFFFFFF
//version constants
#define GRFINGER_FULL                                 1
#define GRFINGER_LIGHT                                2
//Template format constants
#define GR_FORMAT_DEFAULT                             0
#define GR_FORMAT_GR001                               1
#define GR_FORMAT_GR002                               2
#define GR_FORMAT_GR003                               3
#define GR_FORMAT_CLASSIC                           100
#define GR_FORMAT_ISO                               200
#define GR_FORMAT_ANSI                              201
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
#define WM_GR_PLUG                0x400 + GR_PLUG           
#define WM_GR_UNPLUG              0x400 + GR_UNPLUG         
#define WM_GR_FINGER_DOWN         0x400 + GR_FINGER_DOWN    
#define WM_GR_FINGER_UP           0x400 + GR_FINGER_UP      
#define WM_GR_IMAGE               0x400 + GR_IMAGE          
//-------------------------------------------------------------------------------------------------------------------------
#define LP_GR_MAGIC_NUMBER        0x00F4D716
//-------------------------------------------------------------------------------------------------------------------------








