#include "xhbGrFinger.ch"
#include "Hbclass.ch"
//-------------------------------------------------------------------------------------------------------------------------
#xtranslate GrAssert(<exp> [, <n>] [, <c>] ) => ;
  if !<exp> ;
;    Throw(ErrorNew("xhbGrFinger",0,[<n>],ProcName(),[<c>])) ;
; end
//-------------------------------------------------------------------------------------------------------------------------
// #xtranslate GrAssert(<exp> [, <n>] [, <c>] ) =>
//-------------------------------------------------------------------------------------------------------------------------
static _GrFinger_object_ := NIL
//-------------------------------------------------------------------------------------------------------------------------
function TGrFinger()
if _GrFinger_object_ == NIL ; _GrFinger_object_ := TGrFinger_cls_():New() ; end
return _GrFinger_object_
//-------------------------------------------------------------------------------------------------------------------------
CLASS TGrFinger_cls_ STATIC 
EXPORTED:
DATA nLastError
DATA hCtxDict
DATA bSensorPlug     // {|oSensor,cSensor|   ....  }
DATA bSensorUnplug   // {|oSensor,cSensor|   ....  }
DATA aSensor
METHOD New()            // -> Self
METHOD InstallLicense(cKey) // -> lOk
METHOD SetLicenseFolder(cFolder) // -> lOk
METHOD Initialize()     // -> lOk
METHOD Finalize()       // -> lOk
METHOD CreateContext()  // -> oContext | NIL
METHOD GetContext(nCtx) // -> oContext | NIL
METHOD GetBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc) // -> hBmp
METHOD SetBiometricDisplayColors(nMin,nMinMatch,nSeg,nSegMatch,nDir,nDirMatch) // -> lOk
METHOD Version() // -> { nMajor , nMinor , nLicenseTYpe }
METHOD IsBase64Encoding( cStr )   // lBase64
METHOD cBase64ToBin( cBase64 ) //  -> cBin
METHOD cBin2Base64( cBin )     // -> cBase64
METHOD CaptureInit()
METHOD CaptureExit()
METHOD GetSensor(cSensor)
METHOD _OnSensorPlug_(cSensor)
METHOD _OnSensorUnPlug_(cSensor,oSensor)
METHOD CaptureImageFromFile( cFile , nDpi )        
METHOD RawImageToFile( cRaw,cx,cy,cFile,nFmt )
METHOD RawImageToHandle( cRaw,cx,cy,hDC) // -> hBmp
ENDCLASS
//-------------------------------------------------------------------------------------------------------------------------
CLASS TGrContext_cls_ STATIC
EXPORTED:
DATA nCtx
DATA nLastError
METHOD New( nCtx )           // -> Self
METHOD Destroy()             // -> Self
METHOD StartEnroll()         // -> lOk
METHOD Enroll(cRaw,cx,cy,nDpi,nQuality,nFormat)  // Enroll(cRaw,cx,cy,nDpi,@nQuality,nFormat) -> cTemplate
METHOD SetIdentifyParameters( nThreshold , nRotTolerance )
METHOD SetVerifyParameters( nThreshold , nRotTolerance )
METHOD GetIdentifyParameters( nThreshold , nRotTolerance )
METHOD GetVerifyParameters( nThreshold , nRotTolerance )
METHOD Identify(cRefTpl,nScore)  // lMatch
METHOD IdentifyPrepare( cQueryTpl ) // lOk
METHOD GetBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc)
METHOD ConvertTemplate(cOldTpl,nFmt) // -> cNewTp
METHOD Extract(cRawImage,cx,cy,nDpi,nFmt,nQuality) // Extract(cRawImage,cx,cy,nDpi,[nFmt],[@nQuality]) -> cTemplate
METHOD Verify(cQueryTpl,cRefTpl,nScore)  // lMatch
ENDCLASS
//-------------------------------------------------------------------------------------------------------------------------
CLASS TGrSensor_cls_  STATIC
EXPORTED:
DATA cSensor
DATA nLastError
DATA bUnPlug          // {|oSensor,cSensor|   ....  }
DATA bFingerDown      // {|oSensor|   ....  }
DATA bFingerUp        // {|oSensor|   ....  }
DATA bImageReady      // {|oSensor,cRaw,cx,cy,nDpi|   ....  }
DATA lStarted
METHOD New() INLINE Self
METHOD Start()
METHOD Stop()
METHOD _OnFingerDown_()
METHOD _OnFingerUp_()
METHOD _OnImageReady_(cRaw,cx,cy,nDpi)
ENDCLASS
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
// CLASS TGrContext_cls_   METHODS
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
METHOD New(nCtx) CLASS TGrContext_cls_
GrAssert( Valtype(nCtx) == "N" )
::nCtx := nCtx
return Self
//-------------------------------------------------------------------------------------------------------------------------
METHOD Destroy() CLASS TGrContext_cls_
if !Empty(::nCtx )
   ::nLastError := GrDestroyContext( ::nCtx )
   if HHasKey( _GrFinger_object_:hCtxDict , ::nCtx )
      HDel( _GrFinger_object_:hCtxDict , ::nCtx )
   end
end
::nCtx := NIL
return Self
//-------------------------------------------------------------------------------------------------------------------------
METHOD StartEnroll() CLASS TGrContext_cls_
GrAssert( Valtype(::nCtx) == "N" )
::nLastError := GrStartEnroll( ::nCtx )
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Enroll(cRaw,cx,cy,nDpi,nQuality,nFormat) CLASS TGrContext_cls_ // -> cTemplate
local cTpl := NIL
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cRaw) == "C" )
GrAssert( Valtype(cx) == "N" )
GrAssert( Valtype(cy) == "N" )
GrAssert( Valtype(nDpi) == "N" )
GrAssert( (Len(cRaw) >= (cx * cy)) )
if nFormat == NIL ; nFormat := GR_FORMAT_DEFAULT ; end
::nLastError := GrEnroll(cRaw,cx,cy,nDpi,@cTpl,,@nQuality,nFormat,::nCtx)
if ::nLastError != 0 ; return  NIL ; end
return cTpl
//-------------------------------------------------------------------------------------------------------------------------
METHOD SetIdentifyParameters( nThreshold , nRotTolerance )  CLASS TGrContext_cls_ // -> lOk
GrAssert( Valtype(::nCtx) == "N" )
::nLastError := GrSetIdentifyParameters(nThreshold , nRotTolerance ,::nCtx)
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD SetVerifyParameters(nThreshold , nRotTolerance )  CLASS TGrContext_cls_ // -> lOk
GrAssert( Valtype(::nCtx) == "N" )
::nLastError := GrSetVerifyParameters(nThreshold , nRotTolerance ,::nCtx)
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetIdentifyParameters( nThreshold , nRotTolerance )  CLASS TGrContext_cls_ // -> lOk
GrAssert( Valtype(::nCtx) == "N" )
::nLastError := GrGetIdentifyParameters(@nThreshold , @nRotTolerance ,::nCtx)
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetVerifyParameters(nThreshold , nRotTolerance )  CLASS TGrContext_cls_ // -> lOk
GrAssert( Valtype(::nCtx) == "N" )
::nLastError := GrGetVerifyParameters(@nThreshold , @nRotTolerance ,::nCtx)
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD IdentifyPrepare( cQueryTpl )  CLASS TGrContext_cls_  // lOk
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cQueryTpl) == "C" )
::nLastError := GrIdentifyPrepare( cQueryTpl , ::nCtx )
return (::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Identify(cRefTpl,nScore)  CLASS TGrContext_cls_ // lMatch
local nResult
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cRefTpl) == "C" )
nResult := GrIdentify(cRefTpl,@nScore,::nCtx)
if nResult < 0 // Error
   ::nLastError := nResult
   return .F.
end
::nLastError := 0
return ( nResult == GR_MATCH )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Verify(cQueryTpl,cRefTpl,nScore)  CLASS TGrContext_cls_ // lMatch
local nResult
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cRefTpl) == "C" )
GrAssert( Valtype(cQueryTpl) == "C" )
nResult := GrVerify(cQueryTpl,cRefTpl,@nScore,::nCtx)
if nResult < 0 // Error
   ::nLastError := nResult
   return .F.
end
::nLastError := 0
return ( nResult == GR_MATCH )
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc)   CLASS TGrContext_cls_
local hBmp := 0
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cQueryTpl) == "C" )
GrAssert( Valtype(cRawImg) == "C" )
GrAssert( Valtype(cx) == "N" )
GrAssert( Valtype(cy) == "N" )
GrAssert( (Len(cRawImg) >= (cx * cy)) )
::nLastError := GrBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc,@hBmp,::nCtx)
if ::nLastError == GR_OK ; return hBmp ; end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD ConvertTemplate(cOldTpl,nFmt)   CLASS TGrContext_cls_ // -> cNewTp
local cNewTpl := NIL
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cOldTpl) == "C" )
if nFmt == NIL ; nFmt := GR_FORMAT_DEFAULT ; end
::nLastError := GrConvertTemplate(cOldTp,@cNewTpl,0,::nCtx,nFmt)
if ::nLastError == GR_OK ; return cNewTpl ; end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD Extract(cRawImage,cx,cy,nDpi,nFmt,nQuality)   CLASS TGrContext_cls_  // -> cTemplate
local cTpl := NIL
local nResult
GrAssert( Valtype(::nCtx) == "N" )
GrAssert( Valtype(cRawImage) == "C" )
GrAssert( Valtype(cx) == "N" )
GrAssert( Valtype(cy) == "N" )
GrAssert( (Len(cRawImage) >= (cx * cy)) )
if nFmt == NIL ; nFmt := GR_FORMAT_DEFAULT ; end
nResult := GrExtractEx(cRawImage,cx,cy,nDpi,@cTpl,0,::nCtx,nFmt)
if nResult < 0
   ::nLastError := nResult
   return NIL
end
::nLastError := 0
nQuality := nResult
return cTpl
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
// CLASS TGrFinger_cls_  METHODS
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
METHOD New() CLASS TGrFinger_cls_
::nLastError   := 0
::hCtxDict     := Hash()
::aSensor      := {}
HSet( ::hCtxDict ,0, TGrContext_cls_():New(0) )  // Default Context
return Self
//-------------------------------------------------------------------------------------------------------------------------
METHOD InstallLicense(cKey) CLASS TGrFinger_cls_
if cKey == NIL ; cKey := "" ; end
::nLastError := GrInstallLicense( cKey )
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD SetLicenseFolder(cFolder) CLASS TGrFinger_cls_
if cFolder == NIL ; cFolder := "" ; end
::nLastError := GrSetLicenseFolder( cFolder )
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Initialize() CLASS TGrFinger_cls_
::nLastError := GrInitialize()
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Finalize() CLASS TGrFinger_cls_
::nLastError := GrFinalize()
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD CreateContext() CLASS TGrFinger_cls_
local nCtx := 0
local oCtx := NIL
if GrCreateContext( @nCtx ) == 0
   oCtx := TGrContext_cls_():New(nCtx)
   HSet( ::hCtxDict ,nCtx, oCtx)
end
return oCtx
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetContext(nCtx) CLASS TGrFinger_cls_
GrAssert( Valtype(nCtx) == "N" )
if HHasKey( ::hCtxDict , nCtx )
   return HGet( ::hCtxDict , nCtx )
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc)   CLASS TGrFinger_cls_
local hBmp := 0
GrAssert( Valtype(cQueryTpl) == "C" )
::nLastError := GrBiometricDisplay(cQueryTpl,cRawImg,cx,cy,nRes,hDc,@hBmp,GR_NO_CONTEXT)
if ::nLastError == GR_OK ; return hBmp ; end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD SetBiometricDisplayColors(nMin,nMinMatch,nSeg,nSegMatch,nDir,nDirMatch) CLASS TGrFinger_cls_
if nMin       == NIL ; nMin       := GR_IMAGE_NO_COLOR ; end
if nMinMatch  == NIL ; nMinMatch  := GR_IMAGE_NO_COLOR ; end
if nSeg       == NIL ; nSeg       := GR_IMAGE_NO_COLOR ; end
if nSegMatch  == NIL ; nSegMatch  := GR_IMAGE_NO_COLOR ; end
if nDir       == NIL ; nDir       := GR_IMAGE_NO_COLOR ; end
if nDirMatch  == NIL ; nDirMatch  := GR_IMAGE_NO_COLOR ; end
::nLastError := GrSetBiometricDisplayColors(nMin,nMinMatch,nSeg,nSegMatch,nDir,nDirMatch)
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Version() CLASS TGrFinger_cls_ // -> { nMajor , nMinor , nLicenseTYpe } | NIL on error
local nMajor   := 0
local nMinor   := 0
local nLicense := GrGetGrFingerVersion(@nMajor,@nMinor)
return { nMajor , nMinor , nLicense }
//-------------------------------------------------------------------------------------------------------------------------
METHOD IsBase64Encoding( cStr )  CLASS TGrFinger_cls_  // lBase64
GrAssert( Valtype(cStr) == "C" )
return GrIsBase64Encoding( cStr )
//-------------------------------------------------------------------------------------------------------------------------
METHOD cBase64ToBin( cBase64 ) CLASS TGrFinger_cls_  //  -> cBin
GrAssert( Valtype(cBase64) == "C" )
return cGrBase64ToBin( cBase64 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD cBin2Base64( cBin )     CLASS TGrFinger_cls_  // -> cBase64
GrAssert( Valtype(cBin) == "C" )
return cGrBin2Base64( cBin )
//-------------------------------------------------------------------------------------------------------------------------
METHOD CaptureInit() CLASS TGrFinger_cls_
::nLastError := GrCapInitialize({|n,s,c| s:_OnSensorPlug_(c)},{|n,s,c,u| s:_OnSensorUnPlug_(c,u)},Self)
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD CaptureExit() CLASS TGrFinger_cls_
::nLastError := GrCapFinalize()
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD GetSensor(cSensor) CLASS TGrFinger_cls_
if Valtype( cSensor ) == "C" ; return GR_Get_Sensor_Cargo(cSensor) ; end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD _OnSensorPlug_(cSensor) CLASS TGrFinger_cls_
local oSensor
GrAssert( Valtype(cSensor) == "C" )
oSensor := TGrSensor_cls_():New(cSensor)
AAdd( ::aSensor , cSensor )
GR_Set_Sensor_Cargo(oSensor)
if Valtype(::bSensorPlug)  == "B"
   Eval( ::bSensorPlug , oSensor , cSensor )
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD _OnSensorUnPlug_(cSensor,oSensor) CLASS TGrFinger_cls_
local n
GrAssert( Valtype(cSensor) == "C" )
GrAssert( Valtype(oSensor) == "O" )
n := aScan( ::aSensor , cSensor )
if n > 0 ; ADel(::aSensor,n) ; ASize( ::aSensor , Len(::aSensor) -1 ) ; end
if Valtype(::bSensorUnPlug)  == "B"
   Eval( ::bSensorUnPlug , oSensor , cSensor )
end
if Valtype(::oSensor:bUnPlug)  == "B"
   Eval( ::oSensor:bUnPlug , oSensor , cSensor )
end
GR_Set_Sensor_Cargo(NIL)
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD CaptureImageFromFile( cFile , nDpi , bOnImageReady )  CLASS TGrFinger_cls_
local oSensor := ::GetSensor("File")
::nLastError := GR_ERROR_INVALID_ID_SENSOR
if oSensor != NIL                   
   if bOnImageReady != NIL ; oSensor:bImageReady := bOnImageReady ; end 
   ::nLastError := GrCapLoadImageFromFile( cFile , nDpi )
end
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD RawImageToFile( cRaw,cx,cy,cFile,nFmt )  CLASS TGrFinger_cls_
GrAssert( Valtype(cRaw) == "C" )
GrAssert( Valtype(cFile) == "C" )
GrAssert( (Len(cRaw) >= (cx * cy)) )
GrAssert( Valtype(cx) == "N" )
GrAssert( Valtype(cy) == "N" )
if nFmt == NIL ; nFmt := GRCAP_IMAGE_FORMAT_BMP  ; end
::nLastError := GrCapSaveRawImageToFile( cRaw,cx,cy,cFile,nFmt )
return ( ::nLastError == 0 )
//-------------------------------------------------------------------------------------------------------------------------
METHOD RawImageToHandle( cRaw,cx,cy,hDC) CLASS TGrFinger_cls_ // -> hBmp
local hBmp := 0
GrAssert( Valtype(cRaw) == "C" )
GrAssert( (Len(cRaw) >= (cx * cy)) )
GrAssert( Valtype(cx) == "N" )
GrAssert( Valtype(cy) == "N" )
if hDC == NIL ; hDC := 0 ; end
::nLastError := GrCapRawImageToHandle(cRaw,cx,cy,hDC, @hBmp)
if ::nLastError == 0 ; return hBmp ; end
return 0
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
// CLASS TGrSensor_cls_  METHODS
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
METHOD New(cSensor) CLASS TGrSensor_cls_   
GrAssert( Valtype(::cSensor) == "C" )
::cSensor := cSensor
::nLastError := 0
::lStarted   := .F.
return Self
//-------------------------------------------------------------------------------------------------------------------------
METHOD Start()  CLASS TGrSensor_cls_                                                                               
::nLastError := GrCapStartCapture( ::cSensor,{|s| s:_OnFingerDown_() },{|s| s:_OnFingerUp_() },;
                                   {|s,cRaw,cx,cy,nDpi| s:_OnImageReady_(cRaw,cx,cy,nDpi) } )
if (::nLastError == GR_OK ) ; ::lStarted := .T. ; end
return (::nLastError == GR_OK )
//-------------------------------------------------------------------------------------------------------------------------
METHOD Stop()  CLASS TGrSensor_cls_
::nLastError := GrCapStopCapture( ::cSensor )
if (::nLastError == GR_OK ) ; ::lStarted := .F. ; end
return (::nLastError == GR_OK )
//-------------------------------------------------------------------------------------------------------------------------
METHOD _OnFingerDown_() CLASS TGrSensor_cls_
if Valtype( ::bFingerDown ) == "B"
   Eval( ::bFingerDown , Self)
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD _OnFingerUp_() CLASS TGrSensor_cls_
if Valtype( ::bFingerUp ) == "B"
   Eval( ::bFingerUp , Self)
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
METHOD _OnImageReady_(cRaw,cx,cy,nDpi) CLASS TGrSensor_cls_
if Valtype( ::bImageReady ) == "B"
   Eval( ::bImageReady , Self , cRaw,cx,cy,nDpi)
end
return NIL
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
#pragma BEGINDUMP
//-------------------------------------------------------------------------------------------------------------------------
#include "hbapi.h"
#include "hbapiitm.h"
#include "hbvm.h"
#include "hbapierr.h"
#include "windows.h"
#include "xhbGrFinger.ch"
#define _pgrab(n) HeapAlloc(GetProcessHeap(),12,n)
#define _pfree(p) HeapFree(GetProcessHeap(),0,p)
//-------------------------------------------------------------------------------------------------------------------------
static BOOL _gr_load_lib_(void);
#define GRLOADPROC( func , sym  ) p##func = (grft_##func ) GetProcAddress( _hGrFingerDll_ , sym ); \
                                  if( !p##func ){ return FALSE;}
//-------------------------------------------------------------------------------------------------------------------------
#define GR_API_HB_FUNC(  funcname    )  \
static void hb_static##funcname( void );\
HB_FUNC( funcname )\
{\
   if(  _gr_load_lib_() ){hb_static##funcname();} \
   else \
    { \
      PHB_ITEM pError = hb_errNew(); \
      hb_errPutGenCode( pError, 0 ); \
      hb_errPutDescription( pError, "No se ha podido cargar la librera GrFinger.dll V.2009" );\
      hb_errPutSeverity( pError, 2 ); \
      hb_errPutSubSystem( pError, "xhbGrFinger" ); \
      hb_errLaunch( pError ); \
      hb_itemRelease( pError ); \
    }\
}  static void hb_static##funcname( void )
//-------------------------------------------------------------------------------------------------------------------------
typedef void ( __stdcall * grft_StatusCbk )(LPSTR,int);
typedef void ( __stdcall * grft_FingerCbk )(LPSTR,int);
typedef void ( __stdcall * grft_ImageCbk  )(LPSTR,UINT,UINT,LPBYTE,int);
//-------------------------------------------------------------------------------------------------------------------------
typedef int ( __stdcall * grft_GrBiometricDisplay)(LPSTR,LPBYTE,int,int,int,HDC,HBITMAP*,int);
typedef int ( __stdcall * grft_GrCapFinalize)(void);
typedef int ( __stdcall * grft_GrCapInitialize)(grft_StatusCbk);
typedef int ( __stdcall * grft_GrCapLoadImageFromFile)(LPSTR, int);
typedef int ( __stdcall * grft_GrCapRawImageToHandle)(LPBYTE,UINT,UINT,HDC,HBITMAP*);
typedef int ( __stdcall * grft_GrCapSaveRawImageToFile)(LPBYTE,UINT,UINT,LPSTR,int);
typedef int ( __stdcall * grft_GrCapStartCapture)(LPSTR,grft_FingerCbk,grft_ImageCbk);
typedef int ( __stdcall * grft_GrCapStopCapture)(LPSTR);
typedef int ( __stdcall * grft_GrCreateContext)(LPINT);
typedef int ( __stdcall * grft_GrDestroyContext)(int);
typedef int ( __stdcall * grft_GrFinalize)(void);
typedef int ( __stdcall * grft_GrGetGrFingerVersion)(LPBYTE,LPBYTE);
typedef int ( __stdcall * grft_GrGetIdentifyParameters)(LPINT,LPINT,int);
typedef int ( __stdcall * grft_GrGetVerifyParameters)(LPINT,LPINT,int);
typedef int ( __stdcall * grft_GrIdentify)(LPSTR,LPINT,int);
typedef int ( __stdcall * grft_GrIdentifyPrepare)(LPSTR,int);
typedef int ( __stdcall * grft_GrInitialize)(void);
typedef int ( __stdcall * grft_GrSetBiometricDisplayColors)(int,int,int,int,int,int);
typedef int ( __stdcall * grft_GrSetIdentifyParameters)(int,int,int);
typedef int ( __stdcall * grft_GrSetVerifyParameters)(int,int,int);
typedef int ( __stdcall * grft_GrVerify)(LPSTR,LPSTR,LPINT,int);
// ---------------------------------------
typedef int ( __stdcall * grft_GrConvertTemplate   )(LPSTR,LPSTR,LPINT,int,int);
typedef int ( __stdcall * grft_GrEnroll            )(LPBYTE,int,int,int,LPSTR,LPINT,LPINT,int,int);
typedef int ( __stdcall * grft_GrStartEnroll       )(int);
typedef int ( __stdcall * grft_GrExtractEx         )(LPBYTE,int,int,int,LPSTR,LPINT,int,int);
typedef int ( __stdcall * grft_GrInstallLicense    )(LPSTR);
typedef int ( __stdcall * grft_GrSetLicenseFolder  )(LPSTR);
typedef int ( __stdcall * grft_GrDecodeBase64       )(LPSTR,int,LPSTR,LPINT);
typedef int ( __stdcall * grft_GrEncodeBase64       )(LPSTR,int,LPSTR,LPINT);
typedef int ( __stdcall * grft_GrIsBase64Encoding   )(LPSTR,int);
//-------------------------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------------------------
struct GR_CTX_ITEM;
typedef struct
{
   void* pNext;
   int           nId;
   HWND          hWnd;
   LPSTR         pTpl;
} GR_CTX_ITEM;
//-------------------------------------------------------------------------------------------------------------------------
typedef struct
{
   LPSTR         pName;
   PHB_ITEM      cb_OnFingerDown;
   PHB_ITEM      cb_OnFingerUp;
   PHB_ITEM      cb_OnImageReady;
   PHB_ITEM      x_cargo;
} GR_SENSOR_INFO;
//-------------------------------------------------------------------------------------------------------------------------
typedef struct
{
   LPSTR  pSensorName;
   UINT   cx;
   UINT   cy;
   LPBYTE pRawImage;
   int    nDpi;
} GR_IMAGE_EVENT_PARAMS;
//-------------------------------------------------------------------------------------------------------------------------
static char    _pszGrClsName_[]     = "BB763C6D-73C5-4CA1-BD0D-DF1DE5BB76BC";
static HMODULE _hGrFingerDll_       = 0;
static HWND    _hWndGr_             = 0;
static GR_CTX_ITEM * pGrCtxFirst    = 0;
static PHB_ITEM cb_OnSensorPlug     = 0;
static PHB_ITEM cb_OnSensorUnPlug   = 0;
static PHB_ITEM x_cargo             = 0;
//-------------------------------------------------------------------------------------------------------------------------
static grft_GrBiometricDisplay                  pGrBiometricDisplay              = 0;
static grft_GrCapFinalize                       pGrCapFinalize                   = 0;
static grft_GrCapInitialize                     pGrCapInitialize                 = 0;
static grft_GrCapLoadImageFromFile              pGrCapLoadImageFromFile          = 0;
static grft_GrCapRawImageToHandle               pGrCapRawImageToHandle           = 0;
static grft_GrCapSaveRawImageToFile             pGrCapSaveRawImageToFile         = 0;
static grft_GrCapStartCapture                   pGrCapStartCapture               = 0;
static grft_GrCapStopCapture                    pGrCapStopCapture                = 0;
static grft_GrCreateContext                     pGrCreateContext                 = 0;
static grft_GrDestroyContext                    pGrDestroyContext                = 0;
static grft_GrFinalize                          pGrFinalize                      = 0;
static grft_GrGetGrFingerVersion                pGrGetGrFingerVersion            = 0;
static grft_GrGetIdentifyParameters             pGrGetIdentifyParameters         = 0;
static grft_GrGetVerifyParameters               pGrGetVerifyParameters           = 0;
static grft_GrIdentify                          pGrIdentify                      = 0;
static grft_GrIdentifyPrepare                   pGrIdentifyPrepare               = 0;
static grft_GrInitialize                        pGrInitialize                    = 0;
static grft_GrSetBiometricDisplayColors         pGrSetBiometricDisplayColors     = 0;
static grft_GrSetIdentifyParameters             pGrSetIdentifyParameters         = 0;
static grft_GrSetVerifyParameters               pGrSetVerifyParameters           = 0;
static grft_GrVerify                            pGrVerify                        = 0;
// ---------------------
static grft_GrConvertTemplate                   pGrConvertTemplate               = 0;
static grft_GrEnroll                            pGrEnroll                        = 0;
static grft_GrStartEnroll                       pGrStartEnroll                   = 0;
static grft_GrExtractEx                         pGrExtractEx                     = 0;
static grft_GrInstallLicense                    pGrInstallLicense                = 0;
static grft_GrSetLicenseFolder                  pGrSetLicenseFolder              = 0;
static grft_GrDecodeBase64                      pGrDecodeBase64                  = 0;
static grft_GrEncodeBase64                      pGrEncodeBase64                  = 0;
static grft_GrIsBase64Encoding                  pGrIsBase64Encoding              = 0;
//-------------------------------------------------------------------------------------------------------------------------
static void hb_pItemDetachAndRelease( PHB_ITEM * pp )
{
   if( pp )
   {
      PHB_ITEM p = pp[0];
      pp[0] = 0;
      if(p) hb_itemRelease(p);
   }
}
//-------------------------------------------------------------------------------------------------------------------------
static PHB_ITEM _hb_GetParamCbCopy(int nParam)
{
   if( hb_pcount() < nParam ) return 0;
   if( ISBLOCK( nParam ) ) return hb_itemNew( hb_param( nParam, HB_IT_BLOCK ) );
   return 0;
}
//-------------------------------------------------------------------------------------------------------------------------
static PHB_ITEM _hb_GetParamCopy(int nParam)
{
   if( hb_pcount() < nParam ) return 0;
   if( ISNIL(nParam) ) return 0;
   return hb_itemNew( hb_param( nParam, HB_IT_ANY ) );
}
//-------------------------------------------------------------------------------------------------------------------------
static LPBYTE _pdup( LPBYTE pSrc , UINT nSize , UINT nExtra)
{
   if( pSrc && nSize )
   {
      LPBYTE p = _pgrab( nSize + nExtra);
      UINT n;
      for( n=0; n < nSize ; n++ ) p[n] = pSrc[n];
      return p;
   }
   return 0;
}
//-------------------------------------------------------------------------------------------------------------------------
static LPSTR _xdup( LPSTR pSrc ){ return (LPSTR) _pdup( pSrc , lstrlen(pSrc) , 1 ); }
//-------------------------------------------------------------------------------------------------------------------------
static GR_CTX_ITEM * GrCtx_Find( int nId )
{
   GR_CTX_ITEM * p;
   if( !pGrCtxFirst ) return 0;
   for( p=pGrCtxFirst;p; p= (GR_CTX_ITEM*) p->pNext){if( p->nId == nId ){return p;}}
   return 0;
}
//-------------------------------------------------------------------------------------------------------------------------
static GR_CTX_ITEM * GrCtx_New( int nId )
{
   GR_CTX_ITEM * pItem = GrCtx_Find( nId );
   if( pItem ) return pItem;
   pItem = ( GR_CTX_ITEM * ) _pgrab( sizeof( GR_CTX_ITEM ) );
   pItem->nId = nId;
   if( pGrCtxFirst ) pItem->pNext = ( void*) pGrCtxFirst;
   pGrCtxFirst = pItem;
   return pItem;
}
//-------------------------------------------------------------------------------------------------------------------------
static GR_CTX_ITEM * GrCtx_Remove( int nId )
{
   GR_CTX_ITEM * p;
   GR_CTX_ITEM * pPrev = 0;
   if( !pGrCtxFirst ) return 0;
   for( p=pGrCtxFirst;p; pPrev = p , p= (GR_CTX_ITEM*) p->pNext)
   {
      if( p->nId == nId )
      {
         if( pPrev ) pPrev->pNext = p->pNext;
         else pGrCtxFirst = (GR_CTX_ITEM*) p->pNext;
         p->pNext = 0;
         return p;
      }
   }
   return 0;
}
//-------------------------------------------------------------------------------------------------------------------------
static void GrCtx_Delete( GR_CTX_ITEM * pItem )
{
   if( pItem )
   {
      if( pItem->pTpl ) _pfree( (void*) pItem->pTpl );
      _pfree( (void*) pItem);
   }
}
//-------------------------------------------------------------------------------------------------------------------------
static LPSTR GrCtx_SetTpl(int nId , LPSTR pTpl , UINT nSize)
{
   GR_CTX_ITEM * pItem = GrCtx_New(nId); // found or create
   if( pItem->pTpl ){ _pfree( (void*) pItem->pTpl ); pItem->pTpl = 0; }
   if( pTpl && nSize ) return (LPSTR) ( pItem->pTpl = _pdup( (LPBYTE) pTpl , nSize , 1) );
   return (LPSTR) 0;
}
//-------------------------------------------------------------------------------------------------------------------------
GR_SENSOR_INFO * GetSensorInfo( LPSTR pName , BOOL bCreate)
{
   GR_SENSOR_INFO * pSensor = (GR_SENSOR_INFO*) GetProp( _hWndGr_ , pName );
   if( (!pSensor) && bCreate )
   {
      pSensor = (GR_SENSOR_INFO*) _pgrab(sizeof(GR_SENSOR_INFO));
      pSensor->pName = pName;
      SetProp(_hWndGr_,pSensor->pName,(HANDLE) pSensor);
   }
   return pSensor;
}
//-------------------------------------------------------------------------------------------------------------------------
static LRESULT __stdcall gr_wndproc( HWND hWnd , UINT nMsg , WPARAM wp , LPARAM lp )
{
   switch( nMsg )
   {
      case WM_GR_PLUG           :
      {
         if( (lp == LP_GR_MAGIC_NUMBER) && wp )
         {
            GR_SENSOR_INFO * pSensor = GetSensorInfo((LPSTR)wp,TRUE);
            if( cb_OnSensorPlug ) // {|nEvt,uCargo,cSensor|  NIL }
            {
               hb_vmPushEvalSym();
               hb_vmPush(cb_OnSensorPlug);
               hb_vmPushLong( GR_PLUG );
               if( x_cargo ) hb_vmPush(x_cargo);
               else hb_vmPushNil();
               hb_vmPushString(pSensor->pName,lstrlen(pSensor->pName));
               hb_vmDo(3);
            }
         }
         return 0;
      }
      case WM_GR_UNPLUG :
      {
         if( (lp == LP_GR_MAGIC_NUMBER) && wp )
         {
            GR_SENSOR_INFO * pSensor = GetSensorInfo((LPSTR)wp,FALSE);
            if( cb_OnSensorUnPlug ) // {|nEvt,uCargo,cSensor,uSensorCargo|  NIL }
            {
               hb_vmPushEvalSym();
               hb_vmPush(cb_OnSensorUnPlug);
               hb_vmPushLong( GR_UNPLUG );
               if( x_cargo ) hb_vmPush(x_cargo);
               else hb_vmPushNil();
               hb_vmPushString((LPSTR)wp,lstrlen((LPSTR)wp));
               if( (pSensor ? pSensor->x_cargo : 0 ) ) hb_vmPush(pSensor->x_cargo);
               else hb_vmPushNil();
               hb_vmDo(4);
            }
            _pfree( (void*) wp );
            if( pSensor )
            {
               RemoveProp(hWnd,pSensor->pName);
               _pfree( (void*) pSensor->pName  );
               if( pSensor->cb_OnFingerDown  ) hb_itemRelease(pSensor->cb_OnFingerDown );
               if( pSensor->cb_OnFingerUp    ) hb_itemRelease(pSensor->cb_OnFingerUp   );
               if( pSensor->cb_OnImageReady  ) hb_itemRelease(pSensor->cb_OnImageReady );
               if( pSensor->x_cargo          ) hb_itemRelease(pSensor->x_cargo         );
               _pfree( (void*) pSensor );
            }
         }
         return 0;
      }
      case WM_GR_FINGER_DOWN    :
      {
         if( (lp == LP_GR_MAGIC_NUMBER) && wp )
         {
            GR_SENSOR_INFO * pSensor = GetSensorInfo((LPSTR)wp,FALSE);
            _pfree( (void*) wp );
            if( !pSensor) return 0;
            if( pSensor->cb_OnFingerDown ) // {|uSensorCargo|  NIL }
            {
               hb_vmPushEvalSym();
               hb_vmPush(pSensor->cb_OnFingerDown);
               if( (pSensor ? pSensor->x_cargo : 0 ) ) hb_vmPush(pSensor->x_cargo);
               else hb_vmPushNil();
               hb_vmDo(1);
            }
         }
         return 0;
      }
      case WM_GR_FINGER_UP      :
      {
         if( (lp == LP_GR_MAGIC_NUMBER) && wp )
         {
            GR_SENSOR_INFO * pSensor = GetSensorInfo((LPSTR)wp,FALSE);
            _pfree( (void*) wp );
            if( !pSensor) return 0;
            if( pSensor->cb_OnFingerUp ) // {|uSensorCargo|  NIL }
            {
               hb_vmPushEvalSym();
               hb_vmPush(pSensor->cb_OnFingerUp);
               if( (pSensor ? pSensor->x_cargo : 0 ) ) hb_vmPush(pSensor->x_cargo);
               else hb_vmPushNil();
               hb_vmDo(1);
            }
         }
         return 0;
      }
      case WM_GR_IMAGE          :
      {
         if( (lp == LP_GR_MAGIC_NUMBER) && wp )
         {
            GR_IMAGE_EVENT_PARAMS* pp = (GR_IMAGE_EVENT_PARAMS*) wp;
            GR_SENSOR_INFO * pSensor  = GetSensorInfo(pp->pSensorName,FALSE);
            UINT   cx                 = pp->cx;
            UINT   cy                 = pp->cy;
            LPBYTE pRawImage          = pp->pRawImage;
            int    nDpi               = pp->nDpi;
            _pfree( (void*) pp->pSensorName );
            _pfree( (void*) wp );
            if( pSensor->cb_OnImageReady && pSensor ) //  {|s,cRaw,cx,cy,nDpi| NIL },;
            {
               hb_vmPushEvalSym();
               hb_vmPush(pSensor->cb_OnImageReady);
               if( (pSensor ? pSensor->x_cargo : 0 ) ) hb_vmPush(pSensor->x_cargo);
               else hb_vmPushNil();
               hb_vmPushString(pRawImage,cx*cy);
               hb_vmPushLong( (LONG) cx );
               hb_vmPushLong( (LONG) cy );
               hb_vmPushLong( (LONG) nDpi );
               hb_vmDo(5);
            }
         }
         return 0;
      }
      case WM_DESTROY:
      {
         SetWindowLong(hWnd,GWL_WNDPROC, (LONG) DefWindowProc );
         return DefWindowProc(hWnd,nMsg,wp,lp);
      }
   }
   return DefWindowProc(hWnd,nMsg,wp,lp);
}
//-------------------------------------------------------------------------------------------------------------------------
static void __stdcall  _gr_callback_status_finger(LPSTR pSensor,int nEvt)
{
   if( pSensor ) PostMessage( _hWndGr_ , (UINT)(nEvt + 0x400) , (WPARAM) _xdup(pSensor) , LP_GR_MAGIC_NUMBER);
}
//-------------------------------------------------------------------------------------------------------------------------
static void __stdcall  _gr_callback_image(LPSTR pSensor,UINT cx,UINT cy,LPBYTE pRaw ,int nDpi)
{
   if( pSensor && cx && cy && pRaw )
   {
      GR_IMAGE_EVENT_PARAMS* pp = (GR_IMAGE_EVENT_PARAMS*) _pgrab( sizeof(GR_IMAGE_EVENT_PARAMS) );
      pp->pSensorName   = _xdup( pSensor);
      pp->cx            = cx;
      pp->cy            = cy;
      pp->pRawImage     = _pdup(pRaw, cx * cy , 0 );
      pp->nDpi          = nDpi;
      PostMessage( _hWndGr_ , WM_GR_IMAGE , (WPARAM) pp , LP_GR_MAGIC_NUMBER);
   }
}
//-------------------------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(  GRINITIALIZE    )
{
   _gr_load_lib_();
   hb_retnl( (*pGrInitialize)() );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRSETLICENSEFOLDER      )// GrSetLicenseFolder( cDir )
{
   int result = (*pGrSetLicenseFolder)( hb_parc(1) );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRINSTALLLICENSE        )// GrInstallLicense( cProductKey )
{
   int result = (*pGrInstallLicense)( hb_parc(1) );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(  GRFINALIZE )
{
   hb_retnl( (*pGrFinalize)() );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(  GRCREATECONTEXT )
{
   int n        = 0;
   int result   = (*pGrCreateContext)(&n);
   if( result == 0 ) GrCtx_New(n);
   hb_stornl(n,1,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(  GRDESTROYCONTEXT )
{
   int  nCtx   = hb_parnl(1);
   GrCtx_Delete( GrCtx_Remove(nCtx) );
   hb_retnl( (*pGrDestroyContext)(nCtx));
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRVERIFY )
{
   LPSTR pq     = hb_parc(1);
   LPSTR pr     = hb_parc(2);
   int   n      = 0;
   int   nCtx   = hb_parnl(4);
   int   result = (*pGrVerify)(pq,pr,&n,nCtx);
   hb_stornl(n,3,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRIDENTIFYPREPARE ) // GrIdentifyPrepare( cTpl , nCtx ) -> nErrCode
{
   int   nCtx   = hb_parnl(2);
   hb_retnl((*pGrIdentifyPrepare)( GrCtx_SetTpl(nCtx,hb_parc(1),hb_parclen(1)) , nCtx ));
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRIDENTIFY )// GrIdentify (pRef,@nScore,nCtx)
{
   int nScore = 0;
   int result = (*pGrIdentify)( hb_parc(1) , &nScore , hb_parnl(3) );
   hb_stornl(result,2,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRSETIDENTIFYPARAMETERS ) // GrSetIdentifyParameters( nThreshold , nRotTolerance , nCtx )
{
   hb_retnl((*pGrSetIdentifyParameters)(hb_parnl(1),hb_parnl(2),hb_parnl(3)));
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRSETVERIFYPARAMETERS ) // GrSetVerifyParameters( nThreshold , nRotTolerance , nCtx )
{
   hb_retnl((*pGrSetVerifyParameters)(hb_parnl(1),hb_parnl(2),hb_parnl(3)));
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRGETIDENTIFYPARAMETERS ) // GrGetIdentifyParameters( @nThreshold , nRotTolerance , nCtx )
{
   int t = 0;
   int r = 0;
   int result = (*pGrGetIdentifyParameters)(&t,&r,hb_parnl(3));
   hb_stornl(t,1,0);
   hb_stornl(r,2,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRGETVERIFYPARAMETERS ) // GrGetVerifyParameters( @nThreshold , nRotTolerance , nCtx )
{
   int t = 0;
   int r = 0;
   int result = (*pGrGetVerifyParameters)(&t,&r,hb_parnl(3));
   hb_stornl(t,1,0);
   hb_stornl(r,2,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPINITIALIZE ) //GrCapInitialize(bOnSensorPlug,bOnSensorUnplug,uCargo)
{
   hb_pItemDetachAndRelease( &cb_OnSensorPlug   );
   hb_pItemDetachAndRelease( &cb_OnSensorUnPlug );
   hb_pItemDetachAndRelease( &x_cargo);
   cb_OnSensorPlug   = _hb_GetParamCbCopy(1);
   cb_OnSensorUnPlug = _hb_GetParamCbCopy(2);
   x_cargo           = _hb_GetParamCopy(3);
   hb_retnl( (*pGrCapInitialize)( _gr_callback_status_finger ) );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPFINALIZE ) //GrCapFinalize()
{
   hb_pItemDetachAndRelease( &cb_OnSensorPlug   );
   hb_pItemDetachAndRelease( &cb_OnSensorUnPlug );
   hb_pItemDetachAndRelease( &x_cargo);
   hb_retnl( (*pGrCapFinalize)() );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPSTARTCAPTURE ) // GrCapStartCapture( cSensor,bOnFingerDown,bOnFingerUp,bOnImageReady)
{
   int result = GR_ERROR_INVALID_ID_SENSOR;
   if( hb_parclen(1) )
   {
      GR_SENSOR_INFO * pSensor = GetSensorInfo( hb_parc(1),FALSE);
      if( pSensor )
      {
         hb_pItemDetachAndRelease(&(pSensor->cb_OnFingerDown ));
         hb_pItemDetachAndRelease(&(pSensor->cb_OnFingerUp   ));
         hb_pItemDetachAndRelease(&(pSensor->cb_OnImageReady ));
         pSensor->cb_OnFingerDown =  _hb_GetParamCbCopy(2);
         pSensor->cb_OnFingerUp   =  _hb_GetParamCbCopy(3);
         pSensor->cb_OnImageReady =  _hb_GetParamCbCopy(4);
         result = (*pGrCapStartCapture)(pSensor->pName, _gr_callback_status_finger , _gr_callback_image);
      }
   }
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPSTOPCAPTURE  ) // GrCapStopCapture
{
   int result = GR_ERROR_INVALID_ID_SENSOR;
   if( hb_parclen(1) )
   {
      GR_SENSOR_INFO * pSensor = GetSensorInfo( hb_parc(1),FALSE);
      result = (*pGrCapStopCapture)( hb_parc(1) );
      if( pSensor )
      {
         hb_pItemDetachAndRelease(&(pSensor->cb_OnFingerDown ));
         hb_pItemDetachAndRelease(&(pSensor->cb_OnFingerUp   ));
         hb_pItemDetachAndRelease(&(pSensor->cb_OnImageReady ));
         hb_pItemDetachAndRelease(&(pSensor->x_cargo         ));
      }
   }
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPSAVERAWIMAGETOFILE  ) // GrCapSaveRawImageToFile( cRaw,cx,cy,cFile,nFmt )
{
   int result = (*pGrCapSaveRawImageToFile)(  (LPBYTE) hb_parc(1),
                                              (UINT)   hb_parnl(2),
                                              (UINT)   hb_parnl(3),
                                              (LPSTR)  hb_parc(4),
                                              (int)    hb_parnl(5)
                                           );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(  GRCAPLOADIMAGEFROMFILE ) //GrCapLoadImageFromFile( cFName , nRes )
{
   int result = (*pGrCapLoadImageFromFile)( hb_parc(1), hb_parnl(2));
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCAPRAWIMAGETOHANDLE  ) // GrCapRawImageToHandle(cRaw,cx,cy,hDC, @hBmp)
{
   HBITMAP hBmp   = 0;                                          
   HDC     hDC    = (HDC) hb_parnl(4);
   BOOL    bTmpDC = ( BOOL) (hDC == 0);
   int result;
   if( bTmpDC ) hDC = GetDC(0);
   result = (*pGrCapRawImageToHandle)((LPBYTE) hb_parc(1),(UINT)hb_parnl(2),(UINT)hb_parnl(3),hDC,&hBmp);
   if( bTmpDC ) ReleaseDC( 0 , hDC);
   hb_stornl((LONG) hBmp,5,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRBIOMETRICDISPLAY ) // GrBiometricDisplay(cQuery,cRaw,cx,cy,nRes,hDc,@hBmp,nCtx)
{
   HBITMAP hBmp = 0;
   int result = (*pGrBiometricDisplay)( hb_parc(1),(LPBYTE) hb_parc(2),hb_parnl(3),hb_parnl(4),hb_parnl(5),
                                        (HDC) hb_parnl(6),&hBmp,hb_parnl(8));
   hb_stornl((LONG) hBmp,7,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(GRSETBIOMETRICDISPLAYCOLORS) // GrSetBiometricDisplayColors(nMin,nMinMatch,nSeg,nSegMatch,nDir,nDirMatch)
{
   hb_retnl(  (*pGrSetBiometricDisplayColors)( hb_parnl(1),hb_parnl(2),hb_parnl(3),
                                               hb_parnl(4),hb_parnl(5),hb_parnl(6)));
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRGETGRFINGERVERSION  ) // GrGetGrFingerVersion(@nMajor,@nMinor)
{
   BYTE chMajor = 0;
   BYTE chMinor = 0;
   int result = (*pGrGetGrFingerVersion)(&chMajor,&chMinor);
   hb_stornl( ((LONG)chMajor) & 0xFF,1,0);
   hb_stornl( ((LONG)chMinor) & 0xFF,2,0);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRCONVERTTEMPLATE       )// GrConvertTemplate(cOldTp,@cNewTp,@cNewTpSize,nCtx,nFmt)
{
   int    nCtx = hb_parnl(4);
   int    cb   = GR_MAX_SIZE_TEMPLATE;
   LPSTR  p    = (LPSTR) _pgrab(cb+1);
   int    result = (*pGrConvertTemplate)(hb_parc(1),p,&cb,nCtx,hb_parnl(5));
   if( result < 0 ){ hb_storc("",2,0);hb_stornl(0,3,0);}
   else { hb_storclen(p,(UINT)cb,2,0);hb_stornl(cb,3,0);}
   _pfree(p);
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GREXTRACTEX ) //GrExtractEx(cRawImage,cx,cy,nDpi,@cTpl,@nTplSize,nCtx,nFmt)
{
   int    nTpSize = GR_MAX_SIZE_TEMPLATE;
   LPSTR  pTpl    = _pgrab(nTpSize);
   int    result  = (*pGrExtractEx)( (LPBYTE) hb_parc(1),hb_parnl(2),hb_parnl(3),hb_parnl(4),
                                    pTpl,&nTpSize,hb_parnl(7),hb_parnl(8));

   if( result < 0 ){hb_storc("",5,0);hb_stornl(0,6,0);}
   else { hb_storclen(pTpl,(UINT) nTpSize,5,0);hb_stornl(nTpSize,6,0);}
   _pfree( (void*) pTpl );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( CGRBASE64TOBIN )// cGrBase64ToBin( cBase64 ) -> cBin
{
   LPSTR pIn  = hb_parc(1);
   int   cb   = hb_parclen(1);
   LPSTR pOut;
   int result;
   if( !( pIn && cb ) ){ hb_retc(""); return;}
   pOut = (LPSTR) _pgrab(cb+1);
   result = (*pGrDecodeBase64)(pIn,cb,pOut,&cb);
   if( result == GR_OK ) hb_retclen(pOut,cb);
   else hb_ret();
   _pfree( (void*) pOut );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( CGRBIN2BASE64 )// CGrBin2Base64( cBin ) -> cBase64
{
   LPSTR pIn    = hb_parc(1);
   int   cbIn   = hb_parclen(1);
   int   cbOut  = (((int) ((cbIn * 4) / 3)) + 128 + ((cbIn >> 6)*2) );
   LPSTR pOut;
   int result;
   if( !( pIn && cbIn ) ){ hb_retc(""); return;}
   pOut = (LPSTR) _pgrab(cbOut+1);
   result = (*pGrEncodeBase64)(pIn,cbIn,pOut,&cbOut);
   if( result == GR_OK ) hb_retclen(pOut,cbOut);
   else hb_ret();
   _pfree( (void*) pOut );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRISBASE64ENCODING      )// GrIsBase64Encoding( cStr )
{
   LPSTR pIn    = hb_parc(1);
   int   cbIn   = hb_parclen(1);
   if( !( pIn && cbIn ) ){ hb_retl(0); return;}
   hb_retl( (*pGrIsBase64Encoding)(pIn,cbIn) );
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC( GRSTARTENROLL  )// GrStartEnroll( nCtx )
{
   int result = (*pGrStartEnroll)( hb_parnl(1) );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(GRENROLL )// GrEnroll(cRaw,cx,cy,nDpi,@cTpl,@cbTpl,@nQuality,nFormat,nCtx);
{
   int    q       = 0;
   int    cb      = GR_MAX_SIZE_TEMPLATE;
   LPSTR  pTpl    = _pgrab(cb+1);
   int    result  = (*pGrEnroll)(hb_parc(1),hb_parnl(2),hb_parnl(3),hb_parnl(4),pTpl,&cb,&q,hb_parnl(8),hb_parnl(9));
   if( result < 0 ){hb_storc("",5,0);hb_stornl(0,6,0);hb_stornl(0,7,0);}
   else { hb_storclen(pTpl,(UINT)cb,5,0);hb_stornl(cb,6,0);hb_stornl(q,7,0);}
   _pfree( (void*) pTpl );
   hb_retnl(result);
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(GR_SET_SENSOR_CARGO )// GR_Set_Sensor_Cargo(cSensor,uCargo)
{
   GR_SENSOR_INFO * pSensor = GetSensorInfo(hb_parc(1),TRUE);
   hb_pItemDetachAndRelease(&(pSensor->x_cargo         ));
   pSensor->x_cargo         =  _hb_GetParamCopy(2);
   hb_ret();
}
//-------------------------------------------------------------------------------------------------------------------------
GR_API_HB_FUNC(GR_GET_SENSOR_CARGO )// GR_Get_Sensor_Cargo(cSensor)
{
   GR_SENSOR_INFO * pSensor = GetSensorInfo(hb_parc(1),FALSE);
   if( pSensor)
   {
      if( pSensor->x_cargo )
      {
         hb_itemReturn( pSensor->x_cargo );
         return;
      }
   }
   hb_ret();
}
//-------------------------------------------------------------------------------------------------------------------------
static BOOL _gr_load_lib_( void)
{
   if( _hWndGr_ ) return TRUE;
   _hGrFingerDll_ = LoadLibrary( "GrFinger.dll" );
   if( ! _hGrFingerDll_ ){ return FALSE;}
   // ---------------------
   GRLOADPROC( GrInitialize                , "_GrInitialize@0"                 );
   GRLOADPROC( GrFinalize                  , "_GrFinalize@0"                   );
   GRLOADPROC( GrCreateContext             , "_GrCreateContext@4"              );
   GRLOADPROC( GrDestroyContext            , "_GrDestroyContext@4"             );
   GRLOADPROC( GrVerify                    , "_GrVerify@16"                    );
   GRLOADPROC( GrIdentifyPrepare           , "_GrIdentifyPrepare@8"            );
   GRLOADPROC( GrIdentify                  , "_GrIdentify@12"                  );
   GRLOADPROC( GrSetIdentifyParameters     , "_GrSetIdentifyParameters@12"     );
   GRLOADPROC( GrSetVerifyParameters       , "_GrSetVerifyParameters@12"       );
   GRLOADPROC( GrGetIdentifyParameters     , "_GrGetIdentifyParameters@12"     );
   GRLOADPROC( GrGetVerifyParameters       , "_GrGetVerifyParameters@12"       );
   GRLOADPROC( GrCapInitialize             , "_GrCapInitialize@4"              );
   GRLOADPROC( GrCapFinalize               , "_GrCapFinalize@0"                );
   GRLOADPROC( GrCapStartCapture           , "_GrCapStartCapture@12"           );
   GRLOADPROC( GrCapStopCapture            , "_GrCapStopCapture@4"             );
   GRLOADPROC( GrCapSaveRawImageToFile     , "_GrCapSaveRawImageToFile@20"     );
   GRLOADPROC( GrCapLoadImageFromFile      , "_GrCapLoadImageFromFile@8"       );
   GRLOADPROC( GrCapRawImageToHandle       , "_GrCapRawImageToHandle@20"       );
   GRLOADPROC( GrBiometricDisplay          , "_GrBiometricDisplay@32"          );
   GRLOADPROC( GrSetBiometricDisplayColors , "_GrSetBiometricDisplayColors@24" );
   GRLOADPROC( GrGetGrFingerVersion        , "_GrGetGrFingerVersion@8"         );
   // -----------   SDK 2009 -----------------
   GRLOADPROC( GrConvertTemplate           , "_GrConvertTemplate@20"           );
   GRLOADPROC( GrEnroll                    , "_GrEnroll@36"                    );
   GRLOADPROC( GrStartEnroll               , "_GrStartEnroll@4"                );
   GRLOADPROC( GrExtractEx                 , "_GrExtractEx@32"                 );
   GRLOADPROC( GrInstallLicense            , "_GrInstallLicense@4"             );
   GRLOADPROC( GrSetLicenseFolder          , "_GrSetLicenseFolder@4"           );
   GRLOADPROC( GrDecodeBase64              , "_GrDecodeBase64@16"              );
   GRLOADPROC( GrEncodeBase64              , "_GrEncodeBase64@16"              );
   GRLOADPROC( GrIsBase64Encoding          , "_GrIsBase64Encoding@8"           );
   // -------------------------
   {
      WNDCLASSEX wc;
      ZeroMemory( &wc, sizeof(WNDCLASSEX));
      wc.cbSize        = sizeof(WNDCLASSEX) ;
      wc.lpfnWndProc   = DefWindowProc;
      wc.hInstance     = (HINSTANCE) GetModuleHandle(0);
      wc.lpszClassName = _pszGrClsName_;
      RegisterClassEx(&wc);
      _hWndGr_ = CreateWindowEx( 0,_pszGrClsName_,0,0,0,0,0,0,(HWND) -3,0,(HINSTANCE) GetModuleHandle(0),0);
      if( !_hWndGr_ ) return FALSE;
      SetWindowLong(_hWndGr_,GWL_WNDPROC, (LONG) gr_wndproc );
   }
   // ---------------------
   return TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------

#pragma ENDDUMP
//-------------------------------------------------------------------------------------------------------------------------
